<?php
 class wpsg_mod_stock extends wpsg_mod_basic { var $id = 90; var $lizenz = 2; public function __construct() { parent::__construct(); $this->name = __('Lagerbestand', 'wpsg'); $this->group = __('Produkte', 'wpsg'); $this->desc = __('Erlaubt die Verwaltung des Lagerbestandes bei den Produkten.', 'wpsg'); } public function install() { if ($this->shop->get_option('wpsg_mod_stock_template') === false || $this->shop->get_option('wpsg_mod_stock_template') == '') { $this->shop->update_option('wpsg_mod_stock_template', 'ausverkauft.phtml'); } $this->shop->checkDefault('wpsg_mod_stock_showBackendStock', '1'); require_once(WPSG_PATH_WP.'/wp-admin/includes/upgrade.php'); $sql = "CREATE TABLE ".WPSG_TBL_PRODUCTS." (
			  	stock int(11) NOT NULL,
			  	stock_count int(1) NOT NULL,
			) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;"; dbDelta($sql); } public function settings_edit() { $this->shop->view['arTemplates'] = $this->shop->loadProduktTemplates(); $this->shop->render(WPSG_PATH_VIEW.'/mods/mod_stock/settings_edit.phtml'); } public function settings_save() { $this->shop->update_option('wpsg_mod_stock_template', $_REQUEST['wpsg_mod_stock_template']); $this->shop->update_option('wpsg_mod_stock_notemplateswitch', $_REQUEST['wpsg_mod_stock_notemplateswitch']); $this->shop->update_option('wpsg_mod_stock_allow', $_REQUEST['wpsg_mod_stock_allow']); $this->shop->update_option('wpsg_mod_stock_showBackendStock', $_REQUEST['wpsg_mod_stock_showBackendStock']); } public function produkt_ajax() { if ($_REQUEST['wpsg_cmd'] == 'getVariInfo') { if ($this->shop->hasMod('wpsg_mod_varianten')) { $arVari = $this->shop->callMod('wpsg_mod_varianten', 'loadVarianten', array($_REQUEST['edit_id'])); foreach ((array)$arVari as $var_id => $var) { echo '<b>'.__($var['name'], 'wpsg').':</b><br />'; echo '<ul>'; foreach ((array)$var['vari'] as $vari_id => $vari) { echo '<li>'; echo __($vari['name'], 'wpsg').': '.((wpsg_isSizedString($vari['stock']))?$vari['stock']:__('Nicht angegeben!', 'wpsg')); echo '</li>'; } echo '</ul>'; } wpsg_Debug($arVari); } else { die(wpsg_translate(__('Aufrufsfehler! Fehlercode:#1#', 'wpsg'), '90_1')); } die("OK"); } } public function produkt_edit(&$data) { $data = wpsg_array_merge($data, $this->db->fetchRow("
				SELECT
					`stock`, `stock_count`
				FROM
					`".WPSG_TBL_PRODUCTS."`
				WHERE
					`id` = '".wpsg_q($data['id'])."'
			")); } public function produkt_save(&$produkt_id) { $this->db->UpdateQuery(WPSG_TBL_PRODUCTS, array( "stock" => wpsg_q($_REQUEST['wpsg_mod_stock_stock']), "stock_count" => wpsg_q($_REQUEST['wpsg_mod_stock_stock_count']) ), "`id` = '".wpsg_q($produkt_id)."'"); } public function produkt_edit_sidebar(&$produkt_data) { if (isset($_REQUEST['wpsg_lang'])) return; $this->shop->render(WPSG_PATH_VIEW.'/mods/mod_stock/produkt_edit_sidebar.phtml'); } public function renderProdukt_templateSelect(&$produkt_data, &$template_file) { if ($this->shop->get_option('wpsg_mod_stock_notemplateswitch') == '1') return; if ($produkt_data['stock'] <= 0 && $this->shop->get_option('wpsg_mod_stock_template') != '-1') { $template_file = WPSG_PATH_PRODUKTTEMPLATES.$this->shop->get_option('wpsg_mod_stock_template'); } } public function setOrderStatus($order_id, $status_id, $inform) { if (in_array($status_id, array(500)) || $this->shop->view['order']['status'] == 500) { $arProductsBuy = $this->db->fetchAssoc("
					SELECT 
						OP.*							
					FROM
						`".WPSG_TBL_ORDERPRODUCT."` AS OP
							LEFT JOIN `".WPSG_TBL_PRODUCTS."` AS P ON (P.`id` = OP.`p_id`)
					WHERE
						OP.`o_id` = '".wpsg_q($order_id)."' AND
						P.`stock_count` = '1'
				"); foreach ($arProductsBuy as $p) { if (preg_match('/^abo_\d+(.*)/', $p['productkey'])) continue; $var_key = false; if ($this->shop->hasMod('wpsg_mod_varianten')) { if (wpsg_isSizedString($p['mod_vp_varkey']) && preg_match('/^vp_\d+(.*)/', $p['mod_vp_varkey'])) { $var_key = $p['mod_vp_varkey']; } else if (wpsg_isSizedString($p['productkey']) && preg_match('/^vp_\d+(.*)/', $p['productkey'])) { $var_key = $p['productkey']; } } if ($var_key === false) { if ($this->shop->view['order']['status'] == 500) { $this->db->Query("
								UPDATE ".WPSG_TBL_PRODUCTS." SET `stock` = `stock` - ".wpsg_q($p['menge'])." WHERE `id` = '".wpsg_q($p['p_id'])."'
							"); } else { $this->db->Query("
								UPDATE ".WPSG_TBL_PRODUCTS." SET `stock` = `stock` + ".wpsg_q($p['menge'])." WHERE `id` = '".wpsg_q($p['p_id'])."'
							"); } } else { if ($this->shop->view['order']['status'] == 500) { $this->shop->callMod('wpsg_mod_varianten', 'reduceStock', array($var_key, $p['menge'], true)); } else { $this->shop->callMod('wpsg_mod_varianten', 'reduceStock', array($var_key, $p['menge'], false)); } } } } } public function getBestand($produkt_id) { if (is_numeric($produkt_id)) { $stock = $this->db->fetchOne("SELECT P.`stock` FROM `".WPSG_TBL_PRODUCTS."` AS P WHERE P.`id` = '".wpsg_q($produkt_id)."'"); } else if ($this->shop->hasMod('wpsg_mod_varianten')) { $stock = $this->shop->callMod('wpsg_mod_varianten', 'getStockForVarianten', array($produkt_id)); } return $stock; } public function checkBestand(&$produkt_id, &$stock_alt, &$stock_neu) { if (substr($produkt_id, 0, 3) == 'abo') return; $stock = $this->getBestand($produkt_id); if ($stock_alt > $stock || $stock_neu > $stock) { if ($this->shop->get_option('wpsg_mod_stock_allow') != '1') { $this->shop->addFrontendError(__('Menge überschreitet Warenbestand!', 'wpsg')); } else { $this->shop->addFrontendError(__('Menge wurde korrigiert, da sie den Warenbestand überschreitet!', 'wpsg')); $stock_alt = $stock; return -1; } } } public function updateStock(&$produkt_id, &$menge) { if (preg_match('/^vp_(.*)/', $produkt_id)) { $_produkt_id = preg_replace('/(^vp_)|(\/(.*))/', '', $produkt_id); $this->shop->callMod('wpsg_mod_varianten', 'reduceStock', array($produkt_id, $menge)); } else { $_produkt_id = $produkt_id; } $product_data = $this->shop->cache->loadProduct($_produkt_id); if ($product_data['stock_count'] != '1') return; $stock_alt = $this->getBestand($_produkt_id); $stock_alt = $this->db->fetchOne("SELECT `stock` FROM `".WPSG_TBL_PRODUCTS."` WHERE `id` = '".wpsg_q($_produkt_id)."'"); $this->db->UpdateQuery(WPSG_TBL_PRODUCTS, array( 'stock' => ($stock_alt - $menge) ), "`id` = '".wpsg_q($_produkt_id)."'"); } } ?>